setwd("C:/Users/auria/OneDrive/Petaurista research project/Statistics petaurista Le Floch 2020/Context of production petaurista Le Floch 2020")

#### Libraries ####

library(blme)
library("tidyr")       #data 
library(ggpubr)      #graph
library(GGally)
library(dplyr)
library(MASS)
library(RVAideMemoire)  #shapiro test
library(lme4)
library(car)
library(lmtest)
library(MuMIn)
library(reshape)
library(car)
library(tidyr)
library(grDevices)
library(multcomp) 
library(outliers)
library(lsmeans)
library(outliers)
library("tidyr")
library(caret)  #machine learning
library("FactoMineR")   #PCA 
library("factoextra")   #extracting, vizualizing and interpreting results from PCA
library(mda)
library(cowplot)
library(klaR)


#### Data sets ####
ctx<- read.csv("Context all units.csv",header=TRUE,sep=";",dec=",")
ctx$..record_id<-as.factor(ctx$..record_id)
ctx$context<-as.factor(ctx$context)
ctx<- ctx %>% 
  mutate(cont2=ifelse(context=="L"&cam_rep_unit==1,"Lcam",
                      ifelse(context=="L"&cam_rep_unit==0,"L",
                             ifelse(context=="E"&cam_rep_unit==1,"Ecam",
                                    ifelse(context=="E"&cam_rep_unit==0,"E",
                                           ifelse(context=="T"&cam_rep_unit==1,"Tcam",
                                                  ifelse(context=="T"&cam_rep_unit==0,"T",
                                                         ifelse(context=="CE","CE",
                                                                ifelse(context=="CL","CL",
                                                                       ifelse(context=="CPB","CPB",
                                                                              ifelse(context=="CRB","CRB",NA))))))))))) %>% 
  mutate(cont_kroo1=ifelse(context=="L"&cam_rep_kroo1=="yes","Lcam",
                      ifelse(context=="L"&cam_rep_kroo1=="no","L",
                             ifelse(context=="E"&cam_rep_kroo1=="yes","Ecam",
                                    ifelse(context=="E"&cam_rep_kroo1=="no","E",
                                           ifelse(context=="T"&cam_rep_kroo1=="yes","Tcam",
                                                  ifelse(context=="T"&cam_rep_kroo1=="no","T",
                                                         ifelse(context=="CE","CE",
                                                                ifelse(context=="CL","CL",
                                                                       ifelse(context=="CPB","CPB",
                                                                              ifelse(context=="CRB","CRB",NA))))))))))) %>% 
  mutate(cont_tw1=ifelse(context=="L"&cam_rep_tw1=="yes","Lcam",
                           ifelse(context=="L"&cam_rep_tw1=="no","L",
                                  ifelse(context=="E"&cam_rep_tw1=="yes","Ecam",
                                         ifelse(context=="E"&cam_rep_tw1=="no","E",
                                                ifelse(context=="T"&cam_rep_tw1=="yes","Tcam",
                                                       ifelse(context=="T"&cam_rep_tw1=="no","T",
                                                              ifelse(context=="CE","CE",
                                                                     ifelse(context=="CL","CL",
                                                                            ifelse(context=="CPB","CPB",
                                                                                   ifelse(context=="CRB","CRB",NA))))))))))) %>%
  mutate(pbdur=ifelse(is.na(begin_time), 1, begin_time))



#pDFA + PCA
pDFA_all <- read.csv("units cam pet for pDFA.csv",header=TRUE,sep=";",dec=",")
kroo_pdfa <- subset(pDFA_all, species == "p")
cam_pca <- subset(pDFA_all, species == "c" & unit %in% c("krak", "hok", "boom"))

#all units pet and cam
ctx_petcam<- read.csv("Context all units pet-cam.csv",header=TRUE,sep=";",dec=",")



#### pDFA (1)Kroo/eagle leopard tree (2)Kroo inter-indiv ####
## (1) Kroo // Eagle Leopard Tree without campbell's
pdfa_3ctx_nocam <- kroo_pdfa %>%
  subset(context %in% c("T", "L", "E") & cam_response == 0)

#nb of trials per context
pdfa_3ctx_nocam %>%
  group_by(..record_id,context)%>%
  summarise(n=n()) %>% 
  group_by(context)%>%
  summarise(n=n())

#nb of kroo per context
pdfa_3ctx_nocam %>%
  count(context) 

pdfa.res_3_nocam=pDFA.incomplete(test.fac="context",
                           contr.fac="..record_id",
                           variables=c("unit_duration", "average_entropy", "peak_time_relative", "peak_frequency", "low_frequency", "high_frequency", "center_time_relative"),
                           balance.contr.fac.contrib = "mode",
                           pdfa.data=pdfa_3ctx_nocam)
pdfa.res_3_nocam<-data.frame(pdfa.res_3_nocam)




##(2) Kroo // record_id: interindividual variation? 
kroo_pdfa$..record_id <- as.factor(kroo_pdfa$..record_id)
#min 20 observation per individual from 2002 and 2017
pdfa_indiv <- kroo_pdfa %>%
  subset(..record_id %in% c("33", "31","28","35","16","13"))

#nb of trials per context
pdfa_indiv %>%
  group_by(..record_id, context)%>%
  summarise(n=n()) %>% 
  group_by(context)%>%
  summarise(n=n())


pdfa.res_indiv=pDFA.incomplete(test.fac="..record_id",
                               contr.fac="context",
                               variables=c("unit_duration", "average_entropy", "peak_time_relative", "peak_frequency", "low_frequency", "high_frequency", "center_time_relative"),
                               balance.contr.fac.contrib = "no",
                               pdfa.data=pdfa_indiv)
pdfa.res_indiv<-data.frame(pdfa.res_indiv)


#### PCA for graphical representation - Pet 'Kroo' and campbell's units (hok, krak, boom) // Eagle Leopard tree #### 
#make graph representation with non-scaled data 
cam_pca$..record_id <- as.factor(cam_pca$..record_id)
campet_pca <- kroo_pca %>%
  subset(cam_response != 1)
campet_pca$..record_id <- as.factor(campet_pca$..record_id)
campet_pca <- campet_pca %>% bind_rows(cam_pca, id = NULL) %>%
    mutate(unit2 = ifelse(unit=="k"& context =="L", "kroo leopard",
                        ifelse(unit=="k"& context == "E", "kroo eagle",
                               ifelse(unit=="krak", "krak (leopard)",
                                      ifelse(unit=="hok", "hok (eagle)",
                                             ifelse(unit=="k"&context=="T", "kroo tree",
                                                    ifelse(unit=="boom","boom (tree)",NA))))))) %>% 
  subset(!context %in% c("CE", "CL", "CPB")) 



res.pca <- PCA(campet_pca[,c(4:10)], graph = FALSE)                                 

fviz_pca_ind(res.pca,                                                          
             geom.ind = "point",                                                
             col.ind = campet_pca$unit2,                                            
             palette = c("#00AFBB", "#E7B800", "#FC4E07", "#0B4F99", "#702632", "#BC8034"),
             addEllipses = TRUE,                                                
             axes = c(1,2),                                                     
             legend.title = "unit")  

a<-get_pca_var(res.pca)$contrib



#extract PCA dimensions
pca_results <- cbind("record_id" = campet_pca$..record_id, "unit"= campet_pca$unit, "context" = campet_pca$context, res.pca$ind$coord) 
pca_results<-data.frame(pca_results)
pca_results <- pca_results %>%
  mutate(unit2 = ifelse(unit=="k"& context =="L", "Leopard ('kroo')",
                        ifelse(unit=="k"& context == "E", "Eagle ('kroo')",
                               ifelse(unit=="k"& context == "T", "Falling tree ('kroo')",
                                      ifelse(unit=="krak", "Leopard ('krak')",
                                             ifelse(unit=="hok", "Eagle ('hok')",
                                                           ifelse(unit=="boom","Falling tree ('boom')",NA)))))))

pca_results$Dim.1<-as.numeric(pca_results$Dim.1)
pca_results$Dim.2<-as.numeric(pca_results$Dim.2)
pca_results$unit2 = factor(pca_results$unit2, levels=c("Campbell's monkey \nalarm calls to","Eagle ('hok')","Leopard ('krak')","Falling tree ('boom')",
                                                       " ","Lesser spot-nosed monkey \nalarm calls to","Eagle ('kroo')",
                                                       "Leopard ('kroo')","Falling tree ('kroo')"))


theme_set(theme_minimal())

fig2<-ggplot(pca_results,aes(Dim.1,Dim.2,col=unit2,shape=unit2))+
  geom_point()+stat_ellipse(level=0.9)+
  scale_shape_manual(values=c(1,15, 16, 17,1,1,15,16,17),
                     drop=FALSE)+
  scale_color_manual(values=c("white","#12CE31", "#12CE31", "#12CE31","white","white", "#EFC11A", "#EFC11A", "#EFC11A"),
                     drop=FALSE) +
  geom_hline(yintercept = 0,linetype = "dashed")+
  geom_vline(xintercept = 0,linetype = "dashed")+
  ylab("PC2")+xlab("PC1")+
  theme(text = element_text(size = 11),legend.title=element_blank())

ggsave(filename = "fig2.pdf",plot=fig2,width=7,height=4,device = "pdf",dpi=500)

#### Plot graph for call type/contexts of production ####
#eagle, leopard, tree
prob_kroo <- ctx %>%
  subset(kroo_nb == 1 | pet_rep_event == 0 | is.na(kroo_nb)) %>% 
  mutate(kroo_nb=ifelse(is.na(kroo_nb), 0, 1)) %>% 
  group_by(..record_id,context,cam_rep_kroo1,cam_rep_event,cont_kroo1,pet_rep_event) %>% 
  summarise(pet_rep_kroo=sum(kroo_nb)) %>% 
  mutate(pet_rep_kroo=ifelse(pet_rep_event==0, "no",ifelse(pet_rep_kroo==0,"yes, other vocalizations","yes, kroo"))) %>% 
  mutate(pet_rep_kroo=factor(pet_rep_kroo,levels=c("no","yes, other vocalizations","yes, kroo")))
prob_tw <- ctx %>%
  subset(tw_nb == 1 | pet_rep_event == 0 | is.na(tw_nb)) %>% 
  mutate(tw_nb=ifelse(is.na(tw_nb), 0, 1)) %>% 
  group_by(..record_id,context,cam_rep_tw1,cam_rep_event,cont_tw1, pet_rep_event) %>% 
  summarise(pet_rep_tw=sum(tw_nb)) %>% 
  mutate(pet_rep_tw=ifelse(pet_rep_event==0, "no",ifelse(pet_rep_tw==0,"yes, other vocalizations","yes, tchakow"))) %>% 
  mutate(pet_rep_tw=factor(pet_rep_tw,levels=c("no","yes, other vocalizations","yes, tchakow")))
prob_rep_plot <- left_join(prob_kroo,prob_tw,by="..record_id") 
prob_rep_plot <- prob_rep_plot %>%
  mutate(pet_rep=ifelse(pet_rep_kroo=="yes, kroo"&pet_rep_tw=="yes, tchakow", "'kroo' & 'tcha-kow'",
                        ifelse(pet_rep_kroo=="yes, kroo"&pet_rep_tw=="yes, other vocalizations", "'kroo'",
                               ifelse(pet_rep_kroo=="yes, other vocalizations", "'tcha-kow'","no response")))) %>% 
  mutate(cam_rep=ifelse(cam_rep_kroo1=="yes", "yes",
                        ifelse(cam_rep_tw1=="yes", "yes","no"))) %>% 
  mutate(context=context.x) %>% 
  mutate(pet_rep=factor(pet_rep,levels=c("'kroo'","'tcha-kow'","'kroo' & 'tcha-kow'","no response"))) %>%
  mutate(cam_rep2=ifelse(cam_rep=="yes" & context =="E", "yes \nN=8",
                         ifelse(cam_rep=="no" & context =="E", "no \nN=11",
                                ifelse(cam_rep=="yes" & context =="L", "yes \nN=13",
                                       ifelse(cam_rep=="no" & context =="L", "no \nN=18",
                                              ifelse(cam_rep=="yes" & context =="T", "yes \nN=8",
                                                     ifelse(cam_rep=="no" & context =="T", "no \nN=7",NA)))))))


prob_rep_plot_ELT <- subset(prob_rep_plot,context %in% c("E", "L", "T")) %>% 
  group_by(context,cam_rep2,pet_rep) %>% 
  summarise(n=n()) %>% 
  mutate(prop=n/sum(n))

prob_rep_plot_ELT$cam_rep2 <- factor(prob_rep_plot_ELT$cam_rep2, levels = c("yes \nN=8", "yes \nN=13",
                                                                            "no \nN=11","no \nN=18","no \nN=7"))

cont.labs <- c("Eagle","Leopard","Falling tree")
names(cont.labs) <- c("E", "L", "T")

fig3<-ggplot(subset(prob_rep_plot_ELT,pet_rep!="no response"),aes(cam_rep2,prop, fill = pet_rep))+
  geom_bar(stat="identity", color="black") +
  scale_y_continuous(labels=scales::percent)+
  facet_wrap(~context,labeller = labeller(context = cont.labs),scale="free_x")+
  ylab("Trials with vocal response")+ xlab("Campbell's monkey alarm calling")+
  labs(fill = "Call type")+
  theme_bw()+
  theme(text = element_text(size = 11),strip.background = element_rect(fill="white"),
        panel.grid.major = element_blank(),panel.grid.minor = element_blank(), axis.text = element_text(colour="black"))+
  scale_fill_manual(values = c("black", "white", "grey"))



ggsave(filename = "Fig3.pdf",plot=fig3,width=7,height=4,device = "pdf",dpi=500)

##campbell's alarm calls playbacks
prob_kroo_C <- ctx %>%
  subset(context %in% c("CE","CL","CPB") & pbdur <= 30)  %>%
  subset(kroo_nb == 1 | pet_rep_event == 0 | is.na(kroo_nb)) %>% 
  mutate(kroo_nb=ifelse(is.na(kroo_nb), 0, 1)) %>% 
  group_by(..record_id,context, pet_rep_event,cam_pb_general, cam_pb_type) %>% 
  summarise(pet_rep_kroo=sum(kroo_nb)) %>% 
  mutate(pet_rep_kroo=ifelse(pet_rep_event==0, "no",ifelse(pet_rep_kroo==0,"yes, other vocalizations","yes, kroo"))) %>% 
  mutate(pet_rep_kroo=factor(pet_rep_kroo,levels=c("no","yes, other vocalizations","yes, kroo")))
prob_tw_C <- ctx %>%
  subset(context %in% c("CE","CL","CPB") & pbdur <= 30)  %>%
  subset(tw_nb == 1 | pet_rep_event == 0 | is.na(tw_nb)) %>% 
  mutate(tw_nb=ifelse(is.na(tw_nb), 0, 1)) %>% 
  group_by(..record_id,context, pet_rep_event, cam_pb_general, cam_pb_type) %>% 
  summarise(pet_rep_tw=sum(tw_nb)) %>% 
  mutate(pet_rep_tw=ifelse(pet_rep_event==0, "no",ifelse(pet_rep_tw==0,"yes, other vocalizations","yes, tcha-kow"))) %>% 
  mutate(pet_rep_tw=factor(pet_rep_tw,levels=c("no","yes, other vocalizations","yes, tcha-kow")))
prob_rep_plot_C <- left_join(prob_kroo_C,prob_tw_C,by="..record_id") 
prob_rep_plot_C <- prob_rep_plot_C %>%
  mutate(pet_rep=ifelse(pet_rep_kroo=="yes, kroo"&pet_rep_tw=="yes, tcha-kow", "'kroo' & 'tcha-kow'",
                        ifelse(pet_rep_kroo=="yes, kroo"&pet_rep_tw=="yes, other vocalizations", "'kroo'",
                               ifelse(pet_rep_kroo=="yes, other vocalizations", "'tcha-kow'","no response")))) %>% 
  mutate(context=context.x) %>% 
  mutate(pet_rep=factor(pet_rep,levels=c("'kroo'","'tcha-kow'","'kroo' & 'tcha-kow'","no response")))

prob_rep_plot_C <- prob_rep_plot_C %>% 
  group_by(context,pet_rep) %>% 
  summarise(n=n()) %>% 
  mutate(prop=n/sum(n))

fig6<-ggplot(subset(prob_rep_plot_C,pet_rep!="no response"),aes(context,prop, fill = pet_rep))+
  geom_bar(stat="identity",color="black") + 
  scale_y_continuous(labels=scales::percent,limits = c(0,1))+
  ylab("Trials with vocal response")+ xlab("Campbell's monkey alarm call")+
  scale_x_discrete(labels=c("Eagle ('hok') \nN=11","Leopard ('krak')\nN=14","Non-predatory ('boom')\nN=20"))+
  labs(fill = "Call type")+
  theme_bw()+
  scale_fill_manual(values = c("black", "white", "grey"))+
  theme(text = element_text(size = 11),strip.background = element_rect(fill="white"),
        panel.grid.major = element_blank(),panel.grid.minor = element_blank(), axis.text = element_text(colour="black"))

ggsave(filename = "fig6.pdf",plot=fig6,width=7,height=4,device = "pdf", dpi=500)


#### GLM1 & GLMM1: all trials (rep and no rep): probability of vocal response (yes/no) ####
#method: analysis on first kroo to see its corresponding context and cam response (yes/no)

##GLM1 : ELT
prob_rep_ELT <- ctx %>%
  subset(context %in% c("E","L", "T")) %>%
  mutate(cam_rep=ifelse(cam_rep_kroo1=="yes","yes", ifelse(cam_rep_tw1=="yes","yes","no")))

prob_rep_ELT <- prob_rep_ELT %>%
  mutate(cont3=ifelse(context=="L"& cam_rep=="yes","Lcam",
                           ifelse(context=="L"& cam_rep=="no","L",
                                  ifelse(context=="E"& cam_rep=="yes","Ecam",
                                         ifelse(context=="E"& cam_rep=="no","E",
                                                ifelse(context=="T"& cam_rep=="yes","Tcam",
                                                       ifelse(context=="T"& cam_rep=="no","T",NA))))))) %>%
  group_by(..record_id,context,cam_rep,pet_rep_event,cont3, Pb_subtype) %>% 
  summarise(pet_rep_event=sum(pet_rep_event)) %>% 
  mutate(pet_rep=ifelse(pet_rep_event==0, "no","yes"))


prob_rep_ELT %>%
  group_by(..record_id, context, cam_rep) %>%
  summarise(n=n())%>%
  group_by(context, cam_rep) %>%
  summarise(n1=n())
                        


#model
modrepprob<-glm(factor(pet_rep)~context*factor(cam_rep),data=prob_rep_ELT,family = "binomial")
summary(modrepprob)
Anova(modrepprob)


#pairwise comparison
prob_rep_ELT$cont3<-factor(prob_rep_ELT$cont3)
modrepprob<-glm(factor(pet_rep)~cont3,data=prob_rep_ELT,family = "binomial")
summary(glht(modrepprob,mcp(cont3="Tukey")))


## GLMM1 : cam playbacks
prob_rep_C <- ctx %>%
  subset(context %in% c("CE","CL","CPB") & pbdur <= 30)  %>%
  group_by(..record_id,context, pet_rep_event,cam_pb_general, cam_pb_type) %>%
  summarise(pet_rep_event=sum(pet_rep_event)) %>% 
  mutate(pet_rep=ifelse(pet_rep_event==0, "no","yes"))

  
#model
modkprob2<-glmer(factor(pet_rep)~context+(1|cam_pb_general),data=prob_rep_C,family = "binomial")
summary(modkprob2)
Anova(modkprob2)

prob_rep_C %>%
  group_by(..record_id, context) %>%
  summarise(n=n())%>%
  group_by(context) %>%
  summarise(n1=n())

#### GLM2 & GLMM2 : rep trials: first call produced ####

##GLM2 : first unit produced ELT
first_unit_elt <- ctx %>% 
  subset (context %in% c("L","E","T") & pet_unit_nb == 1) 

modfirst<-glm(factor(unit)~context*factor(cam_rep_unit),data=first_unit_elt,family = "binomial")
summary(modfirst)
Anova(modfirst)

first_unit_elt%>%
  group_by(..record_id,context, cam_rep_unit) %>%
  summarise(n=n()) %>%
  group_by(context, cam_rep_unit) %>%
  summarise(n=n()) 

first_unit_elt2 <- ctx %>% 
  subset (context %in% c("L","E","T") & pet_unit_nb == 1) %>% 
  mutate(cam_rep7=ifelse(cam_rep_unit==1 & context =="E", "yes \nN=7",
                        ifelse(cam_rep_unit==0 & context =="E", "no \nN=5",
                               ifelse(cam_rep_unit==1 & context =="L", "yes \nN=3",
                                      ifelse(cam_rep_unit==0 & context =="L", "no \nN=14",
                                             ifelse(cam_rep_unit==1 & context =="T", "yes \nN=6",
                                                    ifelse(cam_rep_unit==0 & context =="T", "no \nN=7",NA)))))))%>%
  group_by(context,cam_rep7,unit) %>% 
  summarise(n=n()) %>% 
  mutate(prop=n/sum(n))

first_unit_elt2$cam_rep7 <- factor(first_unit_elt2$cam_rep7, levels = c("yes \nN=7", "yes \nN=3", "yes \nN=6",
                                                                "no \nN=5","no \nN=14","no \nN=7"))


cont.labs <- c("Eagle","Leopard","Falling tree")
names(cont.labs) <- c("E", "L", "T")

fig4<- ggplot(first_unit_elt2,aes(factor(cam_rep7),prop,fill=unit))+
  geom_bar(stat="identity", color="black") + 
  scale_y_continuous(labels=scales::percent)+
  facet_wrap(~context,labeller = labeller(context = cont.labs),scale="free_x")+
  ylab("Trials with vocal response")+ xlab("Campbell's monkey alarm calling")+
  labs(fill = "Call type")+
  theme_bw()+
  theme(text = element_text(size = 11),strip.background = element_rect(fill="white"),
        panel.grid.major = element_blank(),panel.grid.minor = element_blank(),axis.text = element_text(colour="black"))+
  scale_fill_manual(labels=c("'kroo'","'tcha-kow'"),values = c("black", "white"))

ggsave(filename = "fig4.pdf",plot=fig4,width=7,height=4,device = "pdf",dpi=500)

## GLMM2: first unit produced Campbell's playbacks
first_unit_cpb <- ctx %>% 
  subset (context %in% c("CE","CL","CPB") & pet_unit_nb == 1 & unit %in% c("k","tw") & begin_time <= 30) 

modfirst<-bglmer(factor(unit)~context+(1|cam_pb_general),data=first_unit_cpb,family = "binomial",
                 fixef.prior = normal, cov.prior = NULL)
summary(modfirst)
Anova(modfirst)

#pairwise comparison
summary(glht(modfirst,mcp(context="Tukey")))


first_unit_cpb2 <- ctx %>% 
  subset (context %in% c("CE","CL","CPB") & pet_unit_nb == 1 & unit %in% c("k","tw") & begin_time <= 30) %>% 
  group_by(context,unit) %>% 
  summarise(n=n()) %>% 
  mutate(prop=n/sum(n))

fig7<-  ggplot(first_unit_cpb2,aes(factor(context),prop,fill=unit))+
  geom_bar(stat="identity", color="black") + 
  scale_y_continuous(labels=scales::percent)+
  ylab("Trials with vocal response")+ xlab("Campbell's monkey alarm call")+
  labs(fill = "Call type")+
  theme_bw()+
  scale_x_discrete(labels=c("Eagle ('hok') \nN=9","Leopard ('krak')\nN=5","Non-predatory ('boom')\nN=11"))+
  theme(text = element_text(size = 11),strip.background = element_rect(fill="white"),
        panel.grid.major = element_blank(),panel.grid.minor = element_blank(), axis.text = element_text(colour="black"))+
  scale_fill_manual(labels=c("'kroo'","'tcha-kow'"),values = c("black", "white"))

ggsave(filename = "fig7.pdf",plot=fig7,width=7,height=4,device = "pdf",dpi=500)


#### GLM3 & GLMM3 Kroo: number #### 
##GLM3 : ELT
#method: trials selected if: 1-without cam or 2-with cam BUT first kroo produced AFTER first cam call
nb_kroo_ELT <- ctx %>% 
  subset(context %in% c("E","L", "T") & unit == "k" & ..record_id %in% c("18","19","20","21","22","23","24","25","27","29","30","31","32","33","35","37","38","39","45","47","48","49","50","51","52","54","56","57","58","59","60","61","62","69","70","78") ) %>%
    mutate(cam_rep3=ifelse(cam_rep_event=="yes" & context =="E", "yes \nN=7",
                         ifelse(cam_rep_event=="no" & context =="E", "no \nN=4",
                                ifelse(cam_rep_event=="yes" & context =="L", "yes \nN=3",
                                       ifelse(cam_rep_event=="no" & context =="L", "no \nN=12",
                                              ifelse(cam_rep_event=="yes" & context =="T", "yes \nN=5",
                                                     ifelse(cam_rep_event=="no" & context =="T", "no \nN=5",NA))))))) %>%
  group_by(..record_id, context, cam_rep_unit,cam_rep_event, cam_rep3, cont2) %>%    
  summarise(kroo_total = n())

#model
modknb<-glm.nb(kroo_total~context*factor(cam_rep_event),data=nb_kroo_ELT)
summary(modknb)
Anova(modknb)

#plot
nb_kroo_ELT_sum <- nb_kroo_ELT %>% 
  group_by(context,cam_rep_event) %>% 
  summarise(n=n())


nb_kroo_ELT$cam_rep3 <- factor(nb_kroo_ELT$cam_rep3, levels = c("yes \nN=7", "yes \nN=3", "yes \nN=5",
                                                                            "no \nN=4","no \nN=12","no \nN=5"))
cont.labs <- c("Eagle","Leopard","Falling tree")
names(cont.labs) <- c("E", "L", "T")
g1<-ggplot(nb_kroo_ELT,aes(cam_rep3,kroo_total,fill=cam_rep_event))+
      geom_boxplot(alpha=1,position=position_dodge(0.8))+
      theme_bw() + 
      labs(y= "N 'kroo' per trial", x = element_blank() )+ 
      scale_fill_manual(values=c("#7D8491", "#E8EBEE")) +
      facet_wrap(~context,labeller = labeller(context = cont.labs),scale="free_x")+
      theme(text = element_text(size = 11),legend.position = "none",
            strip.background = element_rect(fill="white"),axis.text = element_text(colour="black"),
            panel.grid.major = element_blank(),panel.grid.minor = element_blank())


                       
##GLMM3: cam playbacks
nb_kroo_C <- ctx %>% 
  subset(context %in% c("CE","CL", "CPB") & unit == "k" & begin_time <=30) %>%
  group_by(..record_id, context, cam_pb_general, cam_pb_type) %>%
  summarise(kroo_total = n())

#model
modknb2<-glmer.nb(kroo_total~context+(1|cam_pb_general),data=nb_kroo_C)
summary(modknb2)
Anova(modknb2)


#pairwise comparison
summary(glht(modknb2,mcp(context="Tukey")))


#plot
nb_kroo_C %>% 
  group_by(context) %>% 
  summarise(n=n())

fig8<-ggplot(nb_kroo_C,aes(context,kroo_total))+
  geom_boxplot(alpha=0.8,position=position_dodge(0.8))+
  theme_bw() + 
  labs(y= "N 'kroo' per trials", x = "Campbell's monkey alarm call")+
  geom_signif(comparisons=list(c("CE", "CPB")), annotations="*", y_position = 18, tip_length = 0.01, vjust=0.2) +
  scale_x_discrete(labels=c("Eagle ('hok') \nN=9","Leopard ('krak')\nN=5","Non-predatory ('boom')\nN=5"))+
  guides(fill=FALSE) +
  theme(text = element_text(size = 11),strip.background = element_rect(fill="white"),
        panel.grid.major = element_blank(),panel.grid.minor = element_blank(), axis.text = element_text(colour="black"))

ggsave(filename = "fig8.pdf",plot=fig8,width=7,height=4,device = "pdf",dpi=500)

  

#### GLM4 & GLMM4 : Kroo: rate of 3 first Kroo ####
## GLM4: ELT
#method: 3 first kroo selected if they were produced in a row either 1-before cam resp (trials without cam + with cam but without cam unit heard first) or 2-after cam response
rate_kroo_ELT <- ctx %>% 
  subset(context %in% c("E","L", "T") & unit == "k" & ..record_id %in% c("18","19","20","21","22","23","25","27","29","31","33","34","35","37","38","39","45","48","49","50","51","52","54","56","57","58","59","60","61","62","69","70","78","79"))

three_k  <-  rate_kroo_ELT %>% 
  subset(unit == "k" & kroo_nb < 4) %>%
  group_by(..record_id) 

#rate 3 kroo  
three_rate <- cast(three_k[,c(1,14,4)],..record_id~kroo_nb)
three_rate <- cbind(three_rate[,c(1,2,4)])
names(three_rate)[names(three_rate) == "1"] <- "begin_first"
names(three_rate)[names(three_rate) == "3"] <- "begin_last"
three_rate <- three_rate %>% 
  mutate(rate_k=(3/(begin_last-begin_first)))
three_rate<-left_join(three_rate,three_k[,c(1,9,11)],by=c("..record_id"="..record_id"))
three_rate <- three_rate  %>%
  group_by(..record_id, rate_k, context,cam_rep_unit) %>% 
  summarise(n=n()) %>% 
  mutate(cam_rep4=ifelse(cam_rep_unit==1 & context =="E", "yes \nN=5",
                       ifelse(cam_rep_unit==0 & context =="E", "no \nN=4",
                              ifelse(cam_rep_unit==1 & context =="L", "yes \nN=3",
                                     ifelse(cam_rep_unit==0 & context =="L", "no \nN=13",
                                            ifelse(cam_rep_unit==1 & context =="T", "yes \nN=3",
                                                   ifelse(cam_rep_unit==0 & context =="T", "no \nN=6",NA))))))) 

#model 
modthree<-glm(rate_k~context*factor(cam_rep_unit),Gamma(link = "inverse"),data=three_rate)
summary(modthree)
Anova(modthree)


#plot
three_rate_sum <- three_rate %>% 
  group_by(context,cam_rep_unit) %>% 
  summarise(n=n())

three_rate$cam_rep4 <- factor(three_rate$cam_rep4, levels = c("yes \nN=5", "yes \nN=3",
                                                                "no \nN=4","no \nN=13","no \nN=6"))
cont.labs <- c("Eagle","Leopard","Falling tree")
names(cont.labs) <- c("E", "L", "T")

g2<-ggplot(three_rate,aes(cam_rep4,rate_k,fill=factor(cam_rep_unit))) + 
  geom_boxplot(alpha=1,position=position_dodge(0.8))+
  theme_bw() + 
  labs(y= "Rate ('kroo'/s)", x = element_blank())+ 
  scale_fill_manual(values=c("#7D8491", "#E8EBEE")) +
  facet_wrap(~context,labeller = labeller(context = cont.labs),scale="free_x")+
  theme(text = element_text(size = 11),legend.position = "none",strip.background = element_rect(fill="white"),
        panel.grid.major = element_blank(),axis.text = element_text(colour="black"),panel.grid.minor = element_blank(),
        strip.background.x = element_blank(),strip.text.x = element_blank())



##GLMM4 : cam playbacks
#method: selection: trials with at least 3 kroos. I don't have CPB trials with more than 2 kroos
rate_kroo_C <- ctx %>% 
  subset(context %in% c("CE", "CL") & unit == "k" & begin_time <= 30 & ..record_id %in% c("3", "13","15","16","66","67","71","73","74","75","77"))

three_k_C  <-  rate_kroo_C %>% 
  subset(unit == "k" & kroo_nb < 4) %>%
  group_by(..record_id, cam_pb_general, cam_pb_type) 

#rate 3 kroo  
three_rate_C <- cast(three_k_C[,c(1,14,4)],..record_id~kroo_nb)
three_rate_C <- cbind(three_rate_C[,c(1,2,4)])
names(three_rate_C)[names(three_rate_C) == "1"] <- "begin_first"
names(three_rate_C)[names(three_rate_C) == "3"] <- "begin_last"
three_rate_C <- three_rate_C %>% 
  mutate(rate_k=(3/(begin_last-begin_first)))
three_rate_C<-left_join(three_rate_C,three_k_C[,c(1:22)],by=c("..record_id"="..record_id"))
three_rate_C <- three_rate_C  %>%
  group_by(..record_id, rate_k, context, cam_pb_general, cam_pb_type) %>% 
  summarise(n=n())

#model 
modthree2<-glmer(rate_k~context+(1|cam_pb_general),Gamma(link = "inverse"),data=three_rate_C)
summary(modthree2)
Anova(modthree2)


#plot
three_rate_C %>% 
  group_by(context) %>% 
  summarise(n=n())

ggplot(three_rate_C,aes(context,rate_k)) + 
  geom_boxplot(alpha=0.6,position=position_dodge(0.8)) +
  theme_bw() +
  labs(y= "Rate (kroo/s)", x = "Campbell's monkey alarm call")+ 
  scale_x_discrete(labels=c("Eagle (hok) \nN=6","Leopard (krak)\nN=5"))+
  guides(fill=FALSE) +
  theme(text = element_text(size = 11),strip.background = element_rect(fill="white"),panel.grid.major = element_blank(),panel.grid.minor = element_blank())

 

#### GLM5 & GLMM5 : Kroo: lag response time (response latency) ####
#method: analysis on first kroo to see its corresponding context and cam response (yes/no)
##GLM5 : ELT
lag_campet_ELT <- ctx_petcam %>% 
  subset(context %in% c("L","E","T") & kroo_nb == 1 | context %in% c("L","E","T") & cam_unit_nb == 1)
lag_pet_ELT <- subset(lag_campet_ELT, species =="p") %>%
mutate(cam_rep5=ifelse(cam_rep_kroo1=="yes" & context =="E", "yes \nN=7",
                       ifelse(cam_rep_kroo1=="no" & context =="E", "no \nN=5",
                              ifelse(cam_rep_kroo1=="yes" & context =="L", "yes \nN=3",
                                     ifelse(cam_rep_kroo1=="no" & context =="L", "no \nN=14",
                                            ifelse(cam_rep_kroo1=="yes" & context =="T", "yes \nN=5",
                                                   ifelse(cam_rep_kroo1=="no" & context =="T", "no \nN=7",NA))))))) 

lag_cam <- subset(lag_campet_ELT, species =="c")

#model
modlag_pet<-glm(begin_time~context*factor(cam_rep_unit), Gamma(link = "inverse"),data=lag_pet_ELT)
summary(modlag_pet)
Anova(modlag_pet)


#plot
lag_pet_sum <- lag_pet_ELT %>% 
  group_by(context,cam_rep_unit) %>% 
  summarise(n=n())



lag_pet_ELT$cam_rep5 <- factor(lag_pet_ELT$cam_rep5, levels = c("yes \nN=7", "yes \nN=3", "yes \nN=5",
                                                              "no \nN=5","no \nN=14","no \nN=7"))
cont.labs <- c("Eagle","Leopard","Falling tree")
names(cont.labs) <- c("E", "L", "T")

g3<-ggplot(lag_pet_ELT,aes(cam_rep5,begin_time,fill=factor(cam_rep_kroo1)))+
  geom_boxplot(alpha=1,position=position_dodge(0.8))+
  theme_bw() + 
  labs(y= "Response latency (s)", x = "Campbell's monkey alarm calling")+
  scale_fill_manual(values=c("#7D8491", "#E8EBEE")) +
  facet_wrap(~context,labeller = labeller(context = cont.labs),scale="free_x")+
  theme(text = element_text(size = 11),legend.position = "none",strip.background = element_rect(fill="white"),
        panel.grid.major = element_blank(),panel.grid.minor = element_blank(),axis.text = element_text(colour="black"),
        strip.background.x = element_blank(),strip.text.x = element_blank())



leg <- get_legend(g3)
g3<-g3+ theme(text = element_text(size = 11),legend.position = "none")
fig5<-ggarrange(g1,g2,g3,labels=c("a", "b", "c"), ncol = 1, nrow = 3,
          font.label = list(size = 12, color = "black", face = "bold"))

ggsave(filename = "fig5.pdf",plot=fig5,width=7,height=7.5,device = "pdf",dpi=500)

## GLMM5: cam playbacks
lag_pet_C <- ctx_petcam %>% 
  subset(!..record_id %in% c("14","17","85","94") & context %in% c("CL","CE","CPB") & kroo_nb == 1 & begin_time <= 30) 
lag_pet_C$context<-as.factor(lag_pet_C$context)

#model
modlag_pet2<-glmer(begin_time~context+(1|cam_pb_general),Gamma(link = "inverse"), data=lag_pet_C)
summary(modlag_pet2)
Anova(modlag_pet2)



#plot
lag_pet_C %>% 
  group_by(context) %>% 
  summarise(n=n())

ggplot(lag_pet_C,aes(context,begin_time))+
  geom_boxplot(alpha=0.6,position=position_dodge(0.8))+
  theme_bw() + 
  labs(y= "Response latency (s)", x = "Campbell's monkey alarm call")+ 
  scale_x_discrete(labels=c("Eagle (hok) \nN=9","Leopard (krak)\nN=5", "Tree (boom)\nN=5"))+
  guides(fill=FALSE) +
  theme(text = element_text(size = 11),strip.background = element_rect(fill="white"),panel.grid.major = element_blank(),panel.grid.minor = element_blank())




#### Tchakow: rep trials (rep only): 'boom' playback lag response #### 
## Lag time, mean and SD  
ctx %>% 
  subset(context == "CPB" & unit == "tw") %>%
  group_by(tw_nb)  %>%
  summarise(mean=mean(begin_time), sd=sd(begin_time), n=n())

# lag time between 1st and 2nd boom
tw1<-subset(ctx[,c(1,3,4,5,9,15)], context == "CPB" & unit == "tw" & tw_nb==1)
tw2<-subset(ctx[,c(1,3,4,5,9,15)], context == "CPB" & unit == "tw" & tw_nb==2)
tw12<-left_join(tw2,tw1,by="..record_id")
lag_12<-tw12 %>% 
  mutate(lag=begin_time.x-end_time.y)
mean(lag_12$lag)
sd(lag_12$lag)

#### data preparation: outliers removed, replace NA by mean, and scale ####
# unit_duration  
for (x in kroo_pdfa$unit_duration){                                      
  outlier(kroo_pdfa$unit_duration)                                       
  res_grubbs<-grubbs.test(kroo_pdfa$unit_duration)                       
  if (res_grubbs$p.value<0.05){
    outU <- which(outlier(kroo_pdfa$unit_duration,logical=TRUE)==TRUE)   
    kroo_pdfa[outU,"unit_duration"]<-NA                                  
  }
} 

# average_entropy
for (x in kroo_pdfa$average_entropy){
  outlier(kroo_pdfa$average_entropy)
  res_grubbs<-grubbs.test(kroo_pdfa$average_entropy)
  if (res_grubbs$p.value<0.05){
    outU <- which(outlier(kroo_pdfa$average_entropy,logical=TRUE)==TRUE)
    kroo_pdfa[outU,"average_entropy"]<-NA
  }
} 


# peak_time_relative
for (x in kroo_pdfa$peak_time_relative){
  outlier(kroo_pdfa$peak_time_relative)
  res_grubbs<-grubbs.test(kroo_pdfa$peak_time_relative)
  if (res_grubbs$p.value<0.05){
    outU <- which(outlier(kroo_pdfa$peak_time_relative,logical=TRUE)==TRUE)
    kroo_pdfa[outU,"peak_time_relative"]<-NA
  }
} 

# peak_frequency
for (x in kroo_pdfa$peak_frequency){
  outlier(kroo_pdfa$peak_frequency)
  res_grubbs<-grubbs.test(kroo_pdfa$peak_frequency)
  if (res_grubbs$p.value<0.05){
    outU <- which(outlier(kroo_pdfa$peak_frequency,logical=TRUE)==TRUE)
    kroo_pdfa[outU,"peak_frequency"]<-NA
  }
} 

# low_frequency
for (x in kroo_pdfa$low_frequency){
  outlier(kroo_pdfa$low_frequency)
  res_grubbs<-grubbs.test(kroo_pdfa$low_frequency)
  if (res_grubbs$p.value<0.05){
    outU <- which(outlier(kroo_pdfa$low_frequency,logical=TRUE)==TRUE)
    kroo_pdfa[outU,"low_frequency"]<-NA
  }
} 

# high_frequency
for (x in kroo_pdfa$high_frequency){
  outlier(kroo_pdfa$high_frequency)
  res_grubbs<-grubbs.test(kroo_pdfa$high_frequency)
  if (res_grubbs$p.value<0.05){
    outU <- which(outlier(kroo_pdfa$high_frequency,logical=TRUE)==TRUE)
    kroo_pdfa[outU,"high_frequency"]<-NA
  }
} 


# center_time_relative
for (x in kroo_pdfa$center_time_relative){
  outlier(kroo_pdfa$center_time_relative)
  res_grubbs<-grubbs.test(kroo_pdfa$center_time_relative)
  if (res_grubbs$p.value<0.05){
    outU <- which(outlier(kroo_pdfa$center_time_relative,logical=TRUE)==TRUE)
    kroo_pdfa[outU,"center_time_relative"]<-NA
  }
} 




#same for campbell's calls
# unit_duration                                              
for (x in cam_pca$unit_duration){                                      
  outlier(cam_pca$unit_duration)                                       
  res_grubbs<-grubbs.test(cam_pca$unit_duration)                       
  if (res_grubbs$p.value<0.05){
    outU <- which(outlier(cam_pca$unit_duration,logical=TRUE)==TRUE)  
    cam_pca[outU,"unit_duration"]<-NA                                  
  }
} 

# average_entropy
for (x in cam_pca$average_entropy){
  outlier(cam_pca$average_entropy)
  res_grubbs<-grubbs.test(cam_pca$average_entropy)
  if (res_grubbs$p.value<0.05){
    outU <- which(outlier(cam_pca$average_entropy,logical=TRUE)==TRUE)
    cam_pca[outU,"average_entropy"]<-NA
  }
} 

# peak_time_relative
for (x in cam_pca$peak_time_relative){
  outlier(cam_pca$peak_time_relative)
  res_grubbs<-grubbs.test(cam_pca$peak_time_relative)
  if (res_grubbs$p.value<0.05){
    outU <- which(outlier(cam_pca$peak_time_relative,logical=TRUE)==TRUE)
    cam_pca[outU,"peak_time_relative"]<-NA
  }
} 

# peak_frequency
for (x in cam_pca$peak_frequency){
  outlier(cam_pca$peak_frequency)
  res_grubbs<-grubbs.test(cam_pca$peak_frequency)
  if (res_grubbs$p.value<0.05){
    outU <- which(outlier(cam_pca$peak_frequency,logical=TRUE)==TRUE)
    cam_pca[outU,"peak_frequency"]<-NA
  }} 


# low_frequency
for (x in cam_pca$low_frequency){
  outlier(cam_pca$low_frequency)
  res_grubbs<-grubbs.test(cam_pca$low_frequency)
  if (res_grubbs$p.value<0.05){
    outU <- which(outlier(cam_pca$low_frequency,logical=TRUE)==TRUE)
    cam_pca[outU,"low_frequency"]<-NA
  }} 

# high_frequency
for (x in cam_pca$high_frequency){
  outlier(cam_pca$high_frequency)
  res_grubbs<-grubbs.test(cam_pca$high_frequency)
  if (res_grubbs$p.value<0.05){
    outU <- which(outlier(cam_pca$high_frequency,logical=TRUE)==TRUE)
    cam_pca[outU,"high_frequency"]<-NA
  }} 


# center_time_relative
for (x in cam_pca$center_time_relative){
  outlier(cam_pca$center_time_relative)
  res_grubbs<-grubbs.test(cam_pca$center_time_relative)
  if (res_grubbs$p.value<0.05){
    outU <- which(outlier(cam_pca$center_time_relative,logical=TRUE)==TRUE)
    cam_pca[outU,"center_time_relative"]<-NA
  }
} 


# replace NA + scale
kroo_pca <-replace_na(kroo_pdfa,as.list(colMeans(kroo_pdfa[,4:11],na.rm=T)))
kroo_pdfa <- kroo_pca %>%
  mutate_at(c(4:11), funs(c(scale(.))))

cam_pca <- replace_na(cam_pca,as.list(colMeans(cam_pca[,4:10],na.rm=T)))
cam_pdfa <- cam_pca %>%
  mutate_at(c(4:11), funs(c(scale(.))))

#### pDFA: script by Mundry ####
# create function for incompletely crossed design
pDFA.incomplete<-function(test.fac, contr.fac, variables,
                          n.to.sel=NULL, n.sel=100, n.perm=1000, pdfa.data, balance.contr.fac.contrib=c("only.complete.ones", "mode", "no")){
  #version from Sept 26 2013
  #n.test.fac.levels.to.sel=NULL,
  pdfa.data=data.frame(na.omit(pdfa.data[, c(variables, test.fac, contr.fac)]))
  pdfa.data[, test.fac]=as.factor(as.character(pdfa.data[, test.fac]))
  pdfa.data[, contr.fac]=as.factor(as.character(pdfa.data[, contr.fac]))
  balance.contr.fac.contrib=balance.contr.fac.contrib[1]
  if(sum(c(test.fac, contr.fac, variables)%in%names(pdfa.data))<(length(variables)+1)){
    stop("not all variables are in pdfa.data")
  }
  cf.tf.tab=table(pdfa.data[, contr.fac], pdfa.data[, test.fac])
  #browser()
  if(balance.contr.fac.contrib=="only.complete.ones"){
    contr.fac.levels.to.sel=row.names(cf.tf.tab)[apply(cf.tf.tab>0, 1, sum)==ncol(cf.tf.tab)]
  }else if(balance.contr.fac.contrib=="mode"){
    xx=apply(cf.tf.tab>0, 1, sum)
    xx=xx[xx==max(xx)]
    xx=xx[length(xx)]
    contr.fac.levels.to.sel=row.names(cf.tf.tab)[apply(cf.tf.tab>0, 1, sum)==xx]
  }else if(balance.contr.fac.contrib=="no"){
    contr.fac.levels.to.sel=levels(pdfa.data[, contr.fac])
  }else if(is.numeric(balance.contr.fac.contrib)){
    if(balance.contr.fac.contrib!=round(balance.contr.fac.contrib)){
      stop("Error: invalid value of balance.contr.fac.contrib (if numeric it must be an integer)")
    }
    if(sum(apply(cf.tf.tab>0, 1, sum)==balance.contr.fac.contrib)==0){
      stop("Error: invalid value of balance.contr.fac.contrib (not available)")
    }
    contr.fac.levels.to.sel=row.names(cf.tf.tab)[apply(cf.tf.tab>0, 1, sum)==balance.contr.fac.contrib]
  }else{
    stop("Error: invalid value of balance.contr.fac.contrib (must be one of \"only.complete.ones\", \"mode\", \"no\", or an integer)")
  }
  #if(length(n.test.fac.levels.to.sel)==0){
  #  n.test.fac.levels.to.sel=rep(min(apply(cf.tf.tab>1, 1, sum)), nrow(cf.tf.tab))
  #}else if(!n.test.fac.levels.to.sel){
  #  n.test.fac.levels.to.sel=apply(cf.tf.tab>1, 1, sum)
  #}else if(max(apply(cf.tf.tab>1, 1, sum))>n.test.fac.levels.to.sel){
  #  stop("n.test.fac.levels.to.sel is larger than minimum available per level of control factor")
  #}
  #browser()
  cf.tf.tab[cf.tf.tab==0]=NA
  if(length(n.to.sel)==0){
    n.to.sel=min(apply(cf.tf.tab, 1, min, na.rm=T))
  }else if(min(apply(cf.tf.tab, 1, min, na.rm=T))<n.to.sel){
    stop("n.to.sel larger than minimum number available per combination of levels of tast and control factor")
  }
  model=as.formula(paste(c(test.fac, paste(variables, collapse="+")), collapse="~"))
  ncf.levels=length(levels(pdfa.data[,contr.fac]))
  ntf.levels=length(levels(pdfa.data[,test.fac]))
  pr.prob=rep(1/ntf.levels, ntf.levels)#define prior probabilities to be equal for either of two groups
  #sort data set to make it easier to permute:
  pdfa.data=pdfa.data[order(pdfa.data[, contr.fac], pdfa.data[, test.fac]), ]
  #create list with levels of test.fac per level of contr.fac (to be randomized later):
  to.sel.from=lapply(levels(pdfa.data[, contr.fac]), function(xcf){
    unique(as.character(pdfa.data[pdfa.data[, contr.fac]==xcf, test.fac]))
  })
  #create list with index values of test.fac levels per level of contr.fac per:
  indices.per.contr.fac.level=lapply(1:length(levels(pdfa.data[, contr.fac])), function(xcf){
    rep(1:length(to.sel.from[[xcf]]), cf.tf.tab[xcf, !is.na(cf.tf.tab[xcf,])])
  })
  #create list with 0s and 1s for the random selection:
  to.sel.from.per.c.f.fac=c()
  for(i in 1:nrow(cf.tf.tab)){
    xrow=cf.tf.tab[i,]
    xrow=xrow[!is.na(xrow)]
    for(j in 1:length(xrow)){
      to.sel.from.per.c.f.fac=c(to.sel.from.per.c.f.fac,
                                list(c(rep(1, n.to.sel), rep(0, xrow[j]-n.to.sel))))
    }
  }
  #initialise test statistics:
  ur.c.val=0
  ur.sel=0
  number=(1:nrow(pdfa.data))
  for (k in 1:n.sel){
    #make random selection of same number of cases per subject
    sel=unlist(lapply(to.sel.from.per.c.f.fac, function(x){
      sample(x, length(x), replace=F)
    }))
    #make random selection of levels of
    #sel.wrt.test.contr.fac=unlist(lapply(1:length(levels(pdfa.data[, contr.fac])), function(xcf){
    #  number[pdfa.data[, contr.fac]==levels(pdfa.data[, contr.fac])[xcf] & pdfa.data[, test.fac]%in%
    #    sample(to.sel.from[[xcf]], n.test.fac.levels.to.sel[xcf], replace=F)]
    #}))
    #sel.index=intersect(number[sel==1], sel.wrt.test.contr.fac)
    sel.index=number[sel==1 & pdfa.data[, contr.fac]%in%contr.fac.levels.to.sel]
    #table(pdfa.data[sel.index, contr.fac], pdfa.data[sel.index, test.fac])
    #do a DFA and store results in 'res':
    res=lda(model, prior=pr.prob, data=pdfa.data[sel.index, ])
    #get predictions and store them in 'pred':
    pred=predict(res, pdfa.data, prior=pr.prob)$class
    ur.sel=ur.sel+sum((pdfa.data[, test.fac]==pred)[sel.index])
    ur.c.val= ur.c.val+ sum((pdfa.data[, test.fac]==pred)[-sel.index])
  }
  #save number of correctly classified calls in variable 'orig.res':
  ur.sel= ur.sel/n.sel
  ur.c.val= ur.c.val/n.sel
  #set P-value to 1 (since original data should be treated as 1 permutation):
  p.sel=1
  p.c.val=1
  all.corr=matrix(NA, nrow=n.perm, ncol=2)
  all.corr[1,1]=ur.sel
  all.corr[1,2]=ur.c.val
  #reformulate model for randomized data:
  model=as.formula(paste(c("rtf", paste(variables, collapse="+")), collapse="~"))
  #browser()
  
  #now the permutation:
  for (k in 1:(n.perm-1)){
    #randomize test.fac within contr.fac levels:
    rtf=as.factor(unlist(lapply(1:nrow(cf.tf.tab), function(x){
      return(sample(to.sel.from[[x]], length(to.sel.from[[x]]), replace=F)[indices.per.contr.fac.level[[x]]])
    })))
    #make random selection of same number of cases per subject
    sel=unlist(lapply(to.sel.from.per.c.f.fac, function(x){
      sample(x, length(x), replace=F)
    }))
    #make random selection of levels of
    #sel.wrt.test.contr.fac=unlist(lapply(1:length(levels(pdfa.data[, contr.fac])), function(xcf){
    #  number[pdfa.data[, contr.fac]==levels(pdfa.data[, contr.fac])[xcf] & pdfa.data[, test.fac]%in%
    #    sample(to.sel.from[[xcf]], n.test.fac.levels.to.sel[xcf], replace=F)]
    #}))
    #sel.index=intersect(number[sel==1], sel.wrt.test.contr.fac)
    sel.index=number[sel==1 & pdfa.data[, contr.fac]%in%contr.fac.levels.to.sel]
    rpdfa.data=data.frame(pdfa.data, rtf)
    rm(rtf, sel)
    #do a DFA and store results in 'res':
    res=lda(model, prior=pr.prob, data=rpdfa.data[sel.index, ])
    #get predictions and store them in 'pred':
    pred=predict(res, rpdfa.data, prior=pr.prob)$class
    ran.sel=sum((rpdfa.data[, "rtf"]==pred)[sel.index])
    ran.c.val=sum((rpdfa.data[, "rtf"]==pred)[-sel.index])
    if (ran.sel>=ur.sel){p.sel = p.sel + 1}
    if (ran.c.val>= ur.c.val){p.c.val= p.c.val + 1}
    all.corr[k+1,1]=ran.sel
    all.corr[k+1,2]=ran.c.val
  }
  what=c("no.corr.classified.selected", "expected.no.corr.classified.selected",
         "percent.correctly.classified.selected", "expected.percent.correctly.classified.selected",
         "P.for.selected",
         "no.corr.cross.classified", "expected.no.corr.cross.classified",
         "percent.corr.cross.classified", "expected.percent.corr.cross.classified", "P.for.cross.classified",
         "no.levels.contr.factor", "no.levels.test.factor", "no.cases",
         "no.cases.selected", "number.cases.selected.per.combin.of.test.and.contr.fac",
         "no.permutations", "no.random.selections", "balance.contr.fac.contrib")
  #... glue all the results together
  result=c(ur.sel, mean(all.corr[-1,1]),
           100*ur.sel/length(sel.index), 100*mean(all.corr[-1,1])/length(sel.index),
           p.sel/n.perm,
           ur.c.val, mean(all.corr[-1,2]),
           100*ur.c.val/(nrow(pdfa.data)-length(sel.index)), 100*mean(all.corr[-1,2])/(nrow(pdfa.data)-length(sel.index)),
           p.c.val/n.perm,
           ncf.levels, ntf.levels, nrow(pdfa.data),
           length(sel.index), min(cf.tf.tab, na.rm=T),
           n.perm, n.sel, balance.contr.fac.contrib)
  names(result)=what
  return(result)#print result on the screen
}

